/* SPDX-License-Identifier: GPL-2.0-or-later */
/*
 * Copyright (C) Telechips Inc.
 */

#ifndef MACH_REG_PHYSICAL_H
#define MACH_REG_PHYSICAL_H

/*
 *    TCC897x DataSheet PART 2 SMU & PMU
 */

#define HwGPIO_BASE			(0x74200000)
#define HwGPIOA_BASE			(0x74200000)
#define HwGPIOB_BASE			(0x74200040)
#define HwGPIOC_BASE			(0x74200080)
#define HwGPIOD_BASE			(0x742000C0)
#define HwGPIOE_BASE			(0x74200100)
#define HwGPIOF_BASE			(0x74200140)
#define HwGPIOG_BASE			(0x74200180)
#define HwGPIOHDMI_BASE			(0x742001C0)
#define HwGPIOADC_BASE			(0x74200200)
#define HwGPIOSD_BASE			(0x74200240)

/*
 * TCC897x DataSheet PART 4 MEMORY BUS
 */

#define HwMBUS_MMU_BASE			(0x73000000)
#define HwMBUS_DDR_PHY_BASE		(0x73420000)
#define HwMBUS_DENALI_CTL_BASE		(0x73500000)
#define HwMBUS_DENALI_PHY_BASE		(0x73600000)
#define HwMBUSCFG_BASE			(0x73810000)
#define HwMBUS_OTP_CTL_BASE		(0x73820000)
#define HwMBUS_AXIBUS_CFG_BASE		(0x73830000)

/*
 * TCC897x DataSheet PART 5 IO BUS
 */

#define HwEHI_BASE			(0x76000000)

#define HwMPEFEC_BASE			(0x76010000)

#define HwSDMMC0_BASE			(0x76020000)
#define HwSDMMC1_BASE			(0x76020200)
#define HwSDMMC2_BASE			(0x76020400)
#define HwSDMMC3_BASE			(0x76020600)
#define HwSDMMC_CHCTRL_BASE		(0x76020800)

#define HwGDMA0_BASE			(0x76030000)
#define HwGDMA1_BASE			(0x76030100)
#define HwGDMA2_BASE			(0x76030200)

#define HwOVERLAYMIXER_BASE		(0x72400000)

#define HwPWM_BASE			(0x76050000)

#define HwSMC_BASE			(0x76060000)

#define HwRTC_BASE			(0x76062000)

#define HwREMOTE_BASE			(0x76070000)

#define HwTSADC_BASE			(0x76064000)

#define HwEDI_BASE			(0x76065000)

#define HwIOBUSCFG_BASE			(0x76066000)

#define HwPROTECT_BASE			(0x76067000)

#define HwAXIBM_BASE			(0x76068000)

#define HwAUDIO3_ADMA_BASE		(0x76100000)
#define HwAUDIO3_DAI_BASE		(0x76101000)
#define HwAUDIO3_CDIF_BASE		(0x76101080)
#define HwAUDIO3_SPDIFTX_BASE		(0x76102000)

#define HwAUDIO0_ADMA_BASE		(0x76200000)
#define HwAUDIO0_DAI_BASE		(0x76201000)
#define HwAUDIO0_CDIF_BASE		(0x76201080)
#define HwAUDIO0_SPDIFTX_BASE		(0x76202000)
#define HwAUDIO0_SPDIFRX_BASE		(0x76202800)

#define HwI2C_MASTER0_BASE		(0x76300000)
#define HwI2C_MASTER1_BASE		(0x76310000)
#define HwI2C_MASTER2_BASE		(0x76320000)
#define HwI2C_MASTER3_BASE		(0x76330000)
#define HwI2C_SLAVE0_BASE		(0x76340000)
#define HwI2C_SLAVE1_BASE		(0x76350000)
#define HwI2C_PORTCFG_BASE		(0x76360000)

#define HwAUDIO1_ADMA_BASE		(0x76400000)
#define HwAUDIO1_DAI_BASE		(0x76401000)

#define HwNFC_BASE			(0x76600000)
#define HwECC_BASE			(0x76600200)
#define HwECCBASE			(0x76600208)

#define HwSMC0_BASE			(0x76700000)
#define HwSMC1_BASE			(0x76700400)
#define HwSMC2_BASE			(0x76700800)
#define HwSMC3_BASE			(0x76700C00)

#define HwTSIF_TX0_BASE			(0x76500000)
#define HwTSIF_TX1_BASE			(0x76800000)

#define HwAUDIO2_ADMA_BASE		(0x76B00000)
#define HwAUDIO2_DAI_BASE		(0x76B01000)

#define HwGPSB0_BASE			(0x76900000)
#define HwGPSB1_BASE			(0x76910000)
#define HwGPSB2_BASE			(0x76920000)
#define HwGPSB3_BASE			(0x76930000)
#define HwGPSB4_BASE			(0x76940000)
#define HwGPSB5_BASE			(0x76950000)
#define HwGPSB_PORTCFG_BASE		(0x76960000)
#define HwGPSB_PIDTABLE_BASE		(0x76970000)

#define HwGPSB_STAT_WOR			Hw8
#define HwGPSB_STAT_RUR			Hw7
#define HwGPSB_STAT_WUR			Hw6
#define HwGPSB_STAT_ROR			Hw5
#define HwGPSB_STAT_RF			Hw4
#define HwGPSB_STAT_WE			Hw3
#define HwGPSB_STAT_RNE			Hw2
#define HwGPSB_STAT_WTH			Hw1
#define HwGPSB_STAT_RTH			Hw0

#define HwGPSB_PIDT(X)			(HwGPSB_PIDTABLE_BASE+(X)*4)
#define HwGPSB_PIDT_CH2			Hw31
#define HwGPSB_PIDT_CH1			Hw30
#define HwGPSB_PIDT_CH0			Hw29

#define HwGPSB_DMAICR_ISD		Hw29
#define HwGPSB_DMAICR_ISP		Hw28
#define HwGPSB_DMAICR_IRQS_TRANS	Hw20
#define HwGPSB_DMAICR_IRQS_RCV		HwZERO
#define HwGPSB_DMAICR_IED_EN		Hw17
#define HwGPSB_DMAICR_IEP_EN		Hw16
#define HwGPSB_DMAICR_IRQPCNT_MASK	(Hw13-1)

#define HwGPSB_DMACTRL_DTE		Hw31
#define HwGPSB_DMACTRL_DRE		Hw30
#define HwGPSB_DMACTRL_CT		Hw29
#define HwGPSB_DMACTRL_END		Hw28
#define HwGPSB_DMACTRL_MP		Hw19
#define HwGPSB_DMACTRL_MS		Hw18
#define HwGPSB_DMACTRL_TXAM(X)		((X)*Hw16)
#define HwGPSB_DMACTRL_TXAM_MULTI	HwGPSB_DMACTRL_TXAM(0)
#define HwGPSB_DMACTRL_TXAM_FIXED	HwGPSB_DMACTRL_TXAM(1)
#define HwGPSB_DMACTRL_TXAM_SINGLE	HwGPSB_DMACTRL_TXAM(2)
#define HwGPSB_DMACTRL_TXAM_MASK	HwGPSB_DMACTRL_TXAM(3)
#define HwGPSB_DMACTRL_RXAM(X)		((X)*Hw14)
#define HwGPSB_DMACTRL_RXAM_MULTI	HwGPSB_DMACTRL_RXAM(0)
#define HwGPSB_DMACTRL_RXAM_FIXED	HwGPSB_DMACTRL_RXAM(1)
#define HwGPSB_DMACTRL_RXAM_SINGLE	HwGPSB_DMACTRL_RXAM(2)
#define HwGPSB_DMACTRL_RXAM_MASK	HwGPSB_DMACTRL_RXAM(3)
#define HwGPSB_DMACTRL_MD_NOR		HwZERO
#define HwGPSB_DMACTRL_MD_MP2TS		Hw4
#define HwGPSB_DMACTRL_PCLR		Hw2
#define HwGPSB_DMACTRL_EN		Hw0

#define HwGPSB_INTEN_DW			Hw31
#define HwGPSB_INTEN_DR			Hw30
#define HwGPSB_INTEN_SWD_BHW		Hw27
#define HwGPSB_INTEN_SWD_HWW		Hw26
#define HwGPSB_INTEN_SRD_BHW		Hw25
#define HwGPSB_INTEN_SRD_HWW		Hw24
#define HwGPSB_INTEN_CFGWTH(X)		((X)*Hw20)
#define HwGPSB_INTEN_CFGWTH_MASK	HwGPSB_INTEN_CFGWTH(7)
#define HwGPSB_INTEN_CFGRTH(X)		((X)*Hw16)
#define HwGPSB_INTEN_CFGRTH_MASK	HwGPSB_INTEN_CFGRTH(7)
#define HwGPSB_INTEN_RC			Hw15
#define HwGPSB_INTEN_WOR		Hw8
#define HwGPSB_INTEN_RUR		Hw7
#define HwGPSB_INTEN_WUR		Hw6
#define HwGPSB_INTEN_ROR		Hw5
#define HwGPSB_INTEN_RF			Hw4
#define HwGPSB_INTEN_WE			Hw3
#define HwGPSB_INTEN_RNE		Hw2
#define HwGPSB_INTEN_WTH		Hw1
#define HwGPSB_INTEN_RTH		Hw0



#define HwGPSB_MODE_DIVLDV(X)		((X)*Hw24)
#define HwGPSB_MODE_DIVLDV_MASK		HwGPSB_MODE_DIVLDV(255)
#define HwGPSB_MODE_TRE			Hw23
#define HwGPSB_MODE_THL			Hw22
#define HwGPSB_MODE_TSU			Hw21
#define HwGPSB_MODE_PCS			Hw20
#define HwGPSB_MODE_PCS_HIGH		Hw20
#define HwGPSB_MODE_PCD			Hw19
#define HwGPSB_MODE_PCD_HIGH		Hw19
#define HwGPSB_MODE_PWD			Hw18
#define HwGPSB_MODE_PWD_RISE		Hw18
#define HwGPSB_MODE_PRD			Hw17
#define HwGPSB_MODE_PRD_FALL		Hw17
#define HwGPSB_MODE_PCK			Hw16
#define HwGPSB_MODE_CRF			Hw15
#define HwGPSB_MODE_CWF			Hw14
#define HwGPSB_MODE_BWS(X)		((X)*Hw8)
#define HwGPSB_MODE_BWS_MASK		HwGPSB_MODE_BWS(31)
#define HwGPSB_MODE_SD			Hw7
#define HwGPSB_MODE_LB			Hw6
#define HwGPSB_MODE_CTF			Hw4
#define HwGPSB_MODE_EN			Hw3
#define HwGPSB_MODE_SLV			Hw2
#define HwGPSB_MODE_MD_SPI		HwZERO
#define HwGPSB_MODE_MD_SSP		Hw0

/*
 * TCC897x DataSheet PART 6 HSIO BUS
 */

#define HwUSB20HOST_EHCI_BASE		(0x71200000)
#define HwUSB20HOST_OHCI_BASE		(0x71300000)

#define HwUSB20PHYCFG_BASE_0		(0x71EA0010)
#define HwUSB20PHYCFG_BASE_1		(0x71EA00E0)
#define HwUSBPHYCFG_BASE		(0x71EA0100)

#define HwUSB20OTG_BASE			(0x71B00000)

#define HwGMAC_BASE			(0x71700000)
#define HwGMACDLY_BASE			(0x71702000)

#define HwHSIOBUSCFG_BASE		(0x71EA0000)

#define HwDMAX_BASE			(0x71EB0000)

#define HwCIPHER_BASE			(0x71EC0000)

/*
 * TCC897x DataSheet PART 7 DISPLAY BUS
 */

#define HwVIOC_BASE			(0x72000000)

#define BASE_ADDR_CPUIF			(0x72100000)
#define BASE_ADDR_VIOC			HwVIOC_BASE

#define HwVIOC_DISP0			(BASE_ADDR_VIOC + 0x0000 + 0x0000)
#define HwVIOC_DISP1			(BASE_ADDR_VIOC + 0x0000 + 0x0100)
#define HwVIOC_DISP2			(BASE_ADDR_VIOC + 0x0000 + 0x0200)

#define HwVIOC_RDMA_GAP			(0x100)
#define HwVIOC_RDMA00			(BASE_ADDR_VIOC + 0x0000 + 0x0400)
#define HwVIOC_RDMA01			(BASE_ADDR_VIOC + 0x0000 + 0x0500)
#define HwVIOC_RDMA02			(BASE_ADDR_VIOC + 0x0000 + 0x0600)
#define HwVIOC_RDMA03			(BASE_ADDR_VIOC + 0x0000 + 0x0700)
#define HwVIOC_RDMA04			(BASE_ADDR_VIOC + 0x0000 + 0x0800)
#define HwVIOC_RDMA05			(BASE_ADDR_VIOC + 0x0000 + 0x0900)
#define HwVIOC_RDMA06			(BASE_ADDR_VIOC + 0x0000 + 0x0A00)
#define HwVIOC_RDMA07			(BASE_ADDR_VIOC + 0x0000 + 0x0B00)
#define HwVIOC_RDMA08			(BASE_ADDR_VIOC + 0x0000 + 0x0C00)
#define HwVIOC_RDMA09			(BASE_ADDR_VIOC + 0x0000 + 0x0D00)
#define HwVIOC_RDMA10			(BASE_ADDR_VIOC + 0x0000 + 0x0E00)
#define HwVIOC_RDMA11			(BASE_ADDR_VIOC + 0x0000 + 0x0F00)
#define HwVIOC_RDMA12			(BASE_ADDR_VIOC + 0x0000 + 0x1000)
#define HwVIOC_RDMA13			(BASE_ADDR_VIOC + 0x0000 + 0x1100)
#define HwVIOC_RDMA14			(BASE_ADDR_VIOC + 0x0000 + 0x1200)
#define HwVIOC_RDMA15			(BASE_ADDR_VIOC + 0x0000 + 0x1300)
#define HwVIOC_RDMA16			(BASE_ADDR_VIOC + 0x0000 + 0x1400)
#define HwVIOC_RDMA17			(BASE_ADDR_VIOC + 0x0000 + 0x1500)

#define HwVIOC_MC0			(BASE_ADDR_VIOC + 0x0000 + 0x1600)
#define HwVIOC_MC1			(BASE_ADDR_VIOC + 0x0000 + 0x1700)

#define HwVIOC_WMIX0			(BASE_ADDR_VIOC + 0x0000 + 0x1800)
#define HwVIOC_WMIX1			(BASE_ADDR_VIOC + 0x0000 + 0x1900)
#define HwVIOC_WMIX2			(BASE_ADDR_VIOC + 0x0000 + 0x1A00)
#define HwVIOC_WMIX3			(BASE_ADDR_VIOC + 0x0000 + 0x1B00)
#define HwVIOC_WMIX4			(BASE_ADDR_VIOC + 0x0000 + 0x1C00)
#define HwVIOC_WMIX5			(BASE_ADDR_VIOC + 0x0000 + 0x1D00)
#define HwVIOC_WMIX6			(BASE_ADDR_VIOC + 0x0000 + 0x1E00)

#define HwVIOC_WMIX0_ALPHA		(BASE_ADDR_VIOC + 0x0000 + 0x1840)
#define HwVIOC_WMIX1_ALPHA		(BASE_ADDR_VIOC + 0x0000 + 0x1940)
#define HwVIOC_WMIX2_ALPHA		(BASE_ADDR_VIOC + 0x0000 + 0x1A40)

#define HwVIOC_SC0			(BASE_ADDR_VIOC + 0x0000 + 0x2000)
#define HwVIOC_SC1			(BASE_ADDR_VIOC + 0x0000 + 0x2100)
#define HwVIOC_SC2			(BASE_ADDR_VIOC + 0x0000 + 0x2200)
#define HwVIOC_SC3			(BASE_ADDR_VIOC + 0x0000 + 0x2300)
#define HwVIOC_SC4			(BASE_ADDR_VIOC + 0x0000 + 0x2400)
#define HwVIOC_SC5			(BASE_ADDR_VIOC + 0x0000 + 0x2500)

#define HwVIOC_WDMA00			(BASE_ADDR_VIOC + 0x0000 + 0x2800)
#define HwVIOC_WDMA01			(BASE_ADDR_VIOC + 0x0000 + 0x2900)
#define HwVIOC_WDMA02			(BASE_ADDR_VIOC + 0x0000 + 0x2A00)
#define HwVIOC_WDMA03			(BASE_ADDR_VIOC + 0x0000 + 0x2B00)
#define HwVIOC_WDMA04			(BASE_ADDR_VIOC + 0x0000 + 0x2C00)
#define HwVIOC_WDMA05			(BASE_ADDR_VIOC + 0x0000 + 0x2D00)
#define HwVIOC_WDMA06			(BASE_ADDR_VIOC + 0x0000 + 0x2E00)
#define HwVIOC_WDMA07			(BASE_ADDR_VIOC + 0x0000 + 0x2F00)
#define HwVIOC_WDMA08			(BASE_ADDR_VIOC + 0x0000 + 0x3000)

#define HwVIOC_DISP0_MIX		(BASE_ADDR_VIOC + 0x0000 + 0x3200)
#define HwVIOC_DISP0_MD			(BASE_ADDR_VIOC + 0x0000 + 0x3300)
#define HwVIOC_DISP1_MIX		(BASE_ADDR_VIOC + 0x0000 + 0x3400)
#define HwVIOC_DISP1_MD			(BASE_ADDR_VIOC + 0x0000 + 0x3500)
#define HwVIOC_DISP2_MIX		(BASE_ADDR_VIOC + 0x0000 + 0x3600)
#define HwVIOC_DISP2_MD			(BASE_ADDR_VIOC + 0x0000 + 0x3700)

#define HwVIOC_DEINTLS			(BASE_ADDR_VIOC + 0x0000 + 0x3800)
#define HwVIOC_FDLY0			(BASE_ADDR_VIOC + 0x0000 + 0x3900)
#define HwVIOC_FDLY1			(BASE_ADDR_VIOC + 0x0000 + 0x3A00)
#define HwVIOC_FIFO			(BASE_ADDR_VIOC + 0x0000 + 0x3B00)
#define HwVIOC_DEBLOCK			(BASE_ADDR_VIOC + 0x0000 + 0x3C00)

#define HwVIOC_VINDEMUX			(BASE_ADDR_VIOC + 0xA800)
#define HwVIOC_VIN00			(BASE_ADDR_VIOC + 0x4000)
#define HwVIOC_VIN01			(BASE_ADDR_VIOC + 0x4400)
#define HwVIOC_VIN10			(BASE_ADDR_VIOC + 0x5000)
#define HwVIOC_VIN11			(BASE_ADDR_VIOC + 0x5400)
#define HwVIOC_VIN20			(BASE_ADDR_VIOC + 0x6000)
#define HwVIOC_VIN21			(BASE_ADDR_VIOC + 0x6400)
#define HwVIOC_VIN30			(BASE_ADDR_VIOC + 0x7000)
#define HwVIOC_VIN31			(BASE_ADDR_VIOC + 0x7400)

#define HwVIOC_FILT2D			(BASE_ADDR_VIOC + 0x8000)
#define HwVIOC_LUT			(BASE_ADDR_VIOC + 0x9000)
#define HwVIOC_LUT_TAB			(BASE_ADDR_VIOC + 0x9400)
#define HwVIOC_CONFIG			(BASE_ADDR_VIOC + 0xA000)
#define HwVIOC_IREQ			(BASE_ADDR_VIOC + 0xA000 + 0x000)
#define HwVIOC_PCONFIG			(BASE_ADDR_VIOC + 0xA000 + 0x040)
#define HwVIOC_POWER			(BASE_ADDR_VIOC + 0xA000 + 0x0C0)
#define HwVIOC_FCODEC			(BASE_ADDR_VIOC + 0xB000)

#define HwVIOC_TIMER_BASE		(BASE_ADDR_VIOC + 0xC000)
#define HwVIOC_TIMER			(BASE_ADDR_VIOC + 0xC000)

#define HwVIOC_VIQE0_BASE		(BASE_ADDR_VIOC + 0xD000)
#define HwVIOC_VIQE1_BASE		(BASE_ADDR_VIOC + 0xE000)
#define  HwVIOC_VIQE0			(HwVIOC_VIQE0_BASE)
#define  HwVIOC_VIQE1			(HwVIOC_VIQE1_BASE)
#define HwVIOC_MMU_BASE			(BASE_ADDR_VIOC + 0xF000)
#define HwVIOC_MMU			(BASE_ADDR_VIOC + 0xF000)

#define HwVIOC_CPUIF			(BASE_ADDR_CPUIF + 0x0000)
#define HwVIOC_CPUIF0			(BASE_ADDR_CPUIF + 0x0000)
#define HwVIOC_CPUIF1			(BASE_ADDR_CPUIF + 0x0100)

#define HwVIOC_OUTCFG			(BASE_ADDR_CPUIF + 0x0200)

#define HwNTSCPAL_BASE			(0x72200000)
#define HwTVE_BASE			(0x72200000)
#define HwNTSCPAL_ENC_CTRL_BASE		(0x72200800)

#define HwTVECMDA_PWDENC_PD		Hw7
#define HwTVECMDA_FDRST_1		Hw6
#define HwTVECMDA_FDRST_0		HwZERO
#define HwTVECMDA_FSCSEL(X)		((X)*Hw4)
#define HwTVECMDA_FSCSEL_NTSC		HwTVECMDA_FSCSEL(0)
#define HwTVECMDA_FSCSEL_PALX		HwTVECMDA_FSCSEL(1)
#define HwTVECMDA_FSCSEL_PALM		HwTVECMDA_FSCSEL(2)
#define HwTVECMDA_FSCSEL_PALCN		HwTVECMDA_FSCSEL(3)
#define HwTVECMDA_FSCSEL_MASK		HwTVECMDA_FSCSEL(3)
#define HwTVECMDA_PEDESTAL		Hw3
#define HwTVECMDA_NO_PEDESTAL		HwZERO
#define HwTVECMDA_PIXEL_SQUARE		Hw2
#define HwTVECMDA_PIXEL_601		HwZERO
#define HwTVECMDA_IFMT_625		Hw1
#define HwTVECMDA_IFMT_525		HwZERO
#define HwTVECMDA_PHALT_PAL		Hw0
#define HwTVECMDA_PHALT_NTSC		HwZERO

#define HwTVECMDB_YBIBLK_BLACK		Hw4
#define HwTVECMDB_YBIBLK_BYPASS		HwZERO
#define HwTVECMDB_CBW(X)		((X)*Hw2)
#define HwTVECMDB_CBW_LOW		HwTVECMDB_CBW(0)
#define HwTVECMDB_CBW_MEDIUM		HwTVECMDB_CBW(1)
#define HwTVECMDB_CBW_HIGH		HwTVECMDB_CBW(2)
#define HwTVECMDB_CBW_MASK		HwTVECMDB_CBW(3)
#define HwTVECMDB_YBW(X)		((X)*Hw0)
#define HwTVECMDB_YBW_LOW		HwTVECMDB_YBW(0)
#define HwTVECMDB_YBW_MEDIUM		HwTVECMDB_YBW(1)
#define HwTVECMDB_YBW_HIGH		HwTVECMDB_YBW(2)
#define HwTVECMDB_YBW_MASK		HwTVECMDB_YBW(3)

#define HwTVEGLK_XT24_24MHZ		Hw4
#define HwTVEGLK_XT24_27MHZ		HwZERO
#define HwTVEGLK_GLKEN_RST_EN		Hw3
#define HwTVEGLK_GLKEN_RST_DIS		~Hw3
#define HwTVEGLK_GLKE(X)		((X)*Hw1)
#define HwTVEGLK_GLKE_INT		HwTVEGLK_GLKE(0)
#define HwTVEGLK_GLKE_RTCO		HwTVEGLK_GLKE(2)
#define HwTVEGLK_GLKE_CLKI		HwTVEGLK_GLKE(3)
#define HwTVEGLK_GLKE_MASK		HwTVEGLK_GLKE(3)
#define HwTVEGLK_GLKEN_GLKPL_HIGH	Hw0
#define HwTVEGLK_GLKEN_GLKPL_LOW	HwZERO

#define HwTVECMDC_CSMDE_EN		Hw7
#define HwTVECMDC_CSMDE_DIS		~Hw7
#define HwTVECMDC_CSMD(X)		((X)*Hw5)
#define HwTVECMDC_CSMD_CSYNC		HwTVECMDC_CSMD(0)
#define HwTVECMDC_CSMD_KEYCLAMP		HwTVECMDC_CSMD(1)
#define HwTVECMDC_CSMD_KEYPULSE		HwTVECMDC_CSMD(2)
#define HwTVECMDC_CSMD_MASK		HwTVECMDC_CSMD(3)
#define HwTVECMDC_RGBSYNC(X)		((X)*Hw3)
#define HwTVECMDC_RGBSYNC_NOSYNC	HwTVECMDC_RGBSYNC(0)
#define HwTVECMDC_RGBSYNC_RGB		HwTVECMDC_RGBSYNC(1)
#define HwTVECMDC_RGBSYNC_G		HwTVECMDC_RGBSYNC(2)
#define HwTVECMDC_RGBSYNC_MASK		HwTVECMDC_RGBSYNC(3)

#define HwTVEDACSEL_DACSEL_CODE0	HwZERO
#define HwTVEDACSEL_DACSEL_CVBS		Hw0

#define HwTVEDACPD_PD_EN		Hw0
#define HwTVEDACPD_PD_DIS		~Hw0

#define HwTVEICNTL_FSIP_ODDHIGH		Hw7
#define HwTVEICNTL_FSIP_ODDLOW		HwZERO
#define HwTVEICNTL_VSIP_HIGH		Hw6
#define HwTVEICNTL_VSIP_LOW		HwZERO
#define HwTVEICNTL_HSIP_HIGH		Hw5
#define HwTVEICNTL_HSIP_LOW		HwZERO
#define HwTVEICNTL_HSVSP_RISING		Hw4
#define HwTVEICNTL_HVVSP_FALLING	HwZERO
#define HwTVEICNTL_VSMD_START		Hw3
#define HwTVEICNTL_VSMD_MID		HwZERO
#define HwTVEICNTL_ISYNC(X)		((X)*Hw0)
#define HwTVEICNTL_ISYNC_FSI		HwTVEICNTL_ISYNC(0)
#define HwTVEICNTL_ISYNC_HVFSI		HwTVEICNTL_ISYNC(1)
#define HwTVEICNTL_ISYNC_HVSI		HwTVEICNTL_ISYNC(2)
#define HwTVEICNTL_ISYNC_VFSI		HwTVEICNTL_ISYNC(3)
#define HwTVEICNTL_ISYNC_VSI		HwTVEICNTL_ISYNC(4)
#define HwTVEICNTL_ISYNC_ESAV_L		HwTVEICNTL_ISYNC(5)
#define HwTVEICNTL_ISYNC_ESAV_F		HwTVEICNTL_ISYNC(6)
#define HwTVEICNTL_ISYNC_FREE		HwTVEICNTL_ISYNC(7)
#define HwTVEICNTL_ISYNC_MASK		HwTVEICNTL_ISYNC(7)

#define HwTVEHVOFFST_INSEL(X)		((X)*Hw6)
#define HwTVEHVOFFST_INSEL_BW16_27MHZ	HwTVEHVOFFST_INSEL(0)
#define HwTVEHVOFFST_INSEL_BW16_13P5MH	HwTVEHVOFFST_INSEL(1)
#define HwTVEHVOFFST_INSEL_BW8_13P5MHZ	HwTVEHVOFFST_INSEL(2)
#define HwTVEHVOFFST_INSEL_MASK		HwTVEHVOFFST_INSEL(3)
#define HwTVEHVOFFST_VOFFST_256		Hw3
#define HwTVEHVOFFST_HOFFST_1024	Hw2
#define HwTVEHVOFFST_HOFFST_512		Hw1
#define HwTVEHVOFFST_HOFFST_256		Hw0

#define HwTVEHSVSO_VSOB_256		Hw6
#define HwTVEHSVSO_HSOB_1024		Hw5
#define HwTVEHSVSO_HSOB_512		Hw4
#define HwTVEHSVSO_HSOB_256		Hw3
#define HwTVEHSVSO_HSOE_1024		Hw2
#define HwTVEHSVSO_HSOE_512		Hw1
#define HwTVEHSVSO_HSOE_256		Hw0

#define HwTVEVSOE_VSOST(X)		((X)*Hw6)
#define HwTVEVSOE_NOVRST_EN		Hw5
#define HwTVEVSOE_NOVRST_NORMAL		HwZERO
#define HwTVEVSOE_VSOE(X)		((X)*Hw0)

#define HwTVEVCTRL_VBICTL(X)		((X)*Hw5)
#define HwTVEVCTRL_VBICTL_NONE		HwTVEVCTRL_VBICTL(0)
#define HwTVEVCTRL_VBICTL_10LINE	HwTVEVCTRL_VBICTL(1)
#define HwTVEVCTRL_VBICTL_1LINE		HwTVEVCTRL_VBICTL(2)
#define HwTVEVCTRL_VBICTL_2LINE		HwTVEVCTRL_VBICTL(3)
#define HwTVEVCTRL_MASK			HwTVEVCTRL_VBICTL(3)
#define HwTVEVCTRL_CCOE_EN		Hw4
#define HwTVEVCTRL_CCEE_EN		Hw3
#define HwTVEVCTRL_CGOE_EN		Hw2
#define HwTVEVCTRL_CGEE_EN		Hw1
#define HwTVEVCTRL_WSSE_EN		Hw0

#define HwTVEVENCON_EN_EN		Hw0
#define HwTVEVENCON_EN_DIS		~Hw0

#define HwTVEVENCIF_MV_1		Hw1
#define HwTVEVENCIF_FMT_1		Hw0
#define HwTVEVENCIF_FMT_0		HwZERO

#define HwHDMI_CTRL_BASE		(0x72300000)
#define HwHDMI_CORE_BASE		(0x72310000)
#define HwHDMI_AES_BASE			(0x72320000)
#define HwHDMI_SPDIF_BASE		(0x72330000)
#define HwHDMI_I2S_BASE			(0x72340000)
#define HwHDMI_CEC_BASE			(0x72350000)

#include "dev_mipi_dsi.h"

#define HwMIPI_DSI			(BASE_ADDR_VIOC  + 0x3C0000)

#define VIOC_LUT_DEV0			0
#define VIOC_LUT_DEV1			1
#define VIOC_LUT_DEV2			2
#define VIOC_LUT_COMP0			3
#define VIOC_LUT_COMP1			4
#define VIOC_LUT_COMP2			5
#define VIOC_LUT_COMP3			6

#define VIOC_LUT_DEV_MAX		VIOC_LUT_DEV1

/*
 * TCC897x DataSheet PART 8 VIDEO BUS
 */

/*
 * TCC897x DataSheet PART 9 Cortex-M4 Bus
 */

#define HwCORTEXM4_PKT_GEN_BASE		(0x79000000)
#define HwCORTEXM4_TS_CIPHER_BASE	(0x79010000)
#define HwCORTEXM4_SECTION_FILTER_BASE	(0x79020000)
#define HwCORTEXM4_PKT_MEM_BASE		(0x79030000)
#define HwCORTEXM4_CODE_MEM_BASE	(0x79080000)
#define HwCORTEXM4_DATA_MEM_BASE	(0x79090000)
#define HwCORTEXM4_MAILBOX0_BASE	(0x790A0000)
#define HwCORTEXM4_MAILBOX1_BASE	(0x790B0000)
#define HwCORTEXM4_TSD_CFG_BASE		(0x790F0000)

/*
 * TCC897x CPU Bus
 */

#define HwCPUBUS_CFG_BASE		(0x77000000)
#define HwCPUBUS_AXI_MATRIX_BASE	(0x77100000)
#define HwCPUBUS_L2CACHE_MISC_CFG_BASE	(0x77300000)

/*
 *    TCC897x ARM peri address
 */

#define HwARMPERI_BASE			(0x77200000)

#define HwARMPERI_SCU_BASE		(0x77200000)
#define HwARMPERI_GIC_BASE		(0x77200100)
#define HwARMPERI_TIMER_GLOBAL_BASE	(0x77200200)
#define HwARMPERI_TIMER_PRIVATE_BASE	(0x77200600)
#define HwARMPERI_INT_DIST_BASE		(0x77201000)

#endif /* MACH_REG_PHYSICAL_H */
